<!DOCTYPE html>

<html lang="en" data-content_root="./">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>mptool &#8212; mptool 0.1.2 documentation</title>
    <link rel="stylesheet" type="text/css" href="_static/pygments.css?v=d1102ebc" />
    <link rel="stylesheet" type="text/css" href="_static/alabaster.css?v=12dfc556" />
    <script src="_static/documentation_options.js?v=92734c54"></script>
    <script src="_static/doctools.js?v=888ff710"></script>
    <script src="_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  

  
  

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <section id="mptool">
<h1>mptool<a class="headerlink" href="#mptool" title="Link to this heading">¶</a></h1>
<div class="toctree-wrapper compound">
</div>
</section>
<section id="introduction">
<h1>Introduction<a class="headerlink" href="#introduction" title="Link to this heading">¶</a></h1>
<p>This is the documentation for mptool, a Python module for enumeration and
sampling of minimal pathways (MPs) in metabolic networks and subnetworks.</p>
<p>MPs are minimal sets of reactions that need to be active (have non-zero flux)
in a metabolic (sub)network to satisfy all constraints on the network as a
whole [1]. They can also be defined as the set of support-minimal flux patterns
from elementary flux vectors (EFVs) [2].</p>
<p>An MP can be found by direct minimization of a mixed-integer linear program
(MILP) or by iterative minimization of multiple linear programs (LPs).
Enumeration of MPs is implemented using both of these approaches, in the
iterative case by computing minimal cut sets (MCSs) in a separate binary
integer program (BIP) [3]. For iterative minimization, enumeration can be
accelerated by using a graph defined by the known MPs to predict unknown MPs,
or it can be randomized to allow random sampling of MPs in cases where complete
enumeration is inconvenient or infeasible.</p>
</section>
<section id="installation">
<h1>Installation<a class="headerlink" href="#installation" title="Link to this heading">¶</a></h1>
<p>To install mptool, run the following command in your terminal:</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>pip<span class="w"> </span>install<span class="w"> </span>mptool
</pre></div>
</div>
<p>Ensure you have Python (≥3.7.0) and the Gurobi optimizer (≥9.0.1) installed before you proceed.</p>
</section>
<section id="api-documentation">
<h1>API Documentation<a class="headerlink" href="#api-documentation" title="Link to this heading">¶</a></h1>
<dl class="py function" id="module-mptool">
<dt class="sig sig-object py" id="mptool.create_lp">
<span class="sig-prename descclassname"><span class="pre">mptool.</span></span><span class="sig-name descname"><span class="pre">create_lp</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">cobra_model</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">parameters</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">{}</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">attributes</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">{}</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#mptool.create_lp" title="Link to this definition">¶</a></dt>
<dd><p>Creates a Gurobi LP model from a COBRA model.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>cobra_model</strong> – COBRA model.</p></li>
<li><p><strong>parameters</strong> – Gurobi parameters.</p></li>
<li><p><strong>attributes</strong> – Gurobi attributes.</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>Gurobi model.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="mptool.find_mps">
<span class="sig-prename descclassname"><span class="pre">mptool.</span></span><span class="sig-name descname"><span class="pre">find_mps</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">model</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">subset</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">{}</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">method</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'iterative'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">graph</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">random</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">bounds</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">{}</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">tighten</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">tol</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1e-09</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">inf</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1000</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">threads</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">max_mps</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">max_t</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">verbose</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">export</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">output_dir</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">''</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#mptool.find_mps" title="Link to this definition">¶</a></dt>
<dd><p>Enumerates or samples MPs in the subset using either direct or iterative
minimization. The iterative method can be accelerated by using a graph or
the order of MPs can be randomized (but not both). Enumeration with the
iterative method also finds MCs.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>model</strong> (<em>Model</em>) – COBRA or Gurobi model to use.</p></li>
<li><p><strong>subset</strong> (<em>Iterable</em>) – The subset of reactions that can be part of MPs. The
reactions ca be given as IDs, Gurobi variables, or COBRA reactions.
If empty, all reactions in the model are included in the subset.</p></li>
<li><p><strong>method</strong> (<em>str</em>) – Minimization method to use (iterative or direct).</p></li>
<li><p><strong>graph</strong> (<em>bool</em>) – Use graph to accelerate enumeration (only iterative)?</p></li>
<li><p><strong>random</strong> (<em>bool</em>) – Randomize order of MPs (only iterative)?</p></li>
<li><p><strong>bounds</strong> (<em>dict</em>) – Flux bounds to replace the flux bounds in the model. A
dict with reaction IDs as keys and tuples of flux bounds as values.</p></li>
<li><p><strong>tighten</strong> (<em>bool</em>) – Use flux variability analysis to tighten bounds?</p></li>
<li><p><strong>tol</strong> (<em>float</em>) – Numerical tolerance (the minimum, 1e-9, is recommended).</p></li>
<li><p><strong>inf</strong> (<em>float</em>) – Largest allowed flux bound (“infinity”).</p></li>
<li><p><strong>threads</strong> (<em>int</em>) – Threads to use for optimizer (0 for all cores).</p></li>
<li><p><strong>max_mps</strong> (<em>int</em>) – Maximum number of MPs to find (0 for no limit, must be
non-zero for random sampling if no time limit is specified).</p></li>
<li><p><strong>max_t</strong> (<em>float</em>) – Maximum time in seconds (0 for no limit, must be
non-zero for random sampling if no MP limit is specified).</p></li>
<li><p><strong>verbose</strong> (<em>bool</em>) – Print information as MPs are found?</p></li>
<li><p><strong>export</strong> (<em>bool</em>) – Write data to files (log, subset, bounds, MPs, and MCs)?</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>MPs found (each MP is a frozenset of reaction IDs).
mcs (set): MCs found (each MC is a frozenset of reaction IDs).
complete (bool): Were all MPs found (cannot be checked for random)?</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>mps (set)</p>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>ValueError</strong> – If arguments are invalid or incompatible.</p></li>
<li><p><strong>TypeError</strong> – If model is not COBRA or Gurobi model.</p></li>
<li><p><strong>AssertionError</strong> – If model is infeasible.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="mptool.fva">
<span class="sig-prename descclassname"><span class="pre">mptool.</span></span><span class="sig-name descname"><span class="pre">fva</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">model</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">verbose</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#mptool.fva" title="Link to this definition">¶</a></dt>
<dd><p>Flux variability analysis (FVA).</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>model</strong> (<em>Model</em>) – Gurobi model to use.</p></li>
<li><p><strong>verbose</strong> (<em>bool</em>) – Print information?</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p><p>Reaction IDs are keys and flux bounds are values.
solutions (dict): Tuples of reaction ID and objective sense are keys</p>
<blockquote>
<div><p>and flux bounds are values.</p>
</div></blockquote>
</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>bounds (dict)</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="mptool.load_bounds">
<span class="sig-prename descclassname"><span class="pre">mptool.</span></span><span class="sig-name descname"><span class="pre">load_bounds</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">path</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#mptool.load_bounds" title="Link to this definition">¶</a></dt>
<dd><p>Loads bounds from CSV file to dict.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="mptool.load_cobra_model">
<span class="sig-prename descclassname"><span class="pre">mptool.</span></span><span class="sig-name descname"><span class="pre">load_cobra_model</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">path</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#mptool.load_cobra_model" title="Link to this definition">¶</a></dt>
<dd><p>Loads a single COBRA model from SBML, JSON, or MATLAB file.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="mptool.load_cobra_models">
<span class="sig-prename descclassname"><span class="pre">mptool.</span></span><span class="sig-name descname"><span class="pre">load_cobra_models</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">paths</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">suffixes</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">('sbml',</span> <span class="pre">'xml',</span> <span class="pre">'json',</span> <span class="pre">'mat')</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#mptool.load_cobra_models" title="Link to this definition">¶</a></dt>
<dd><p>Loads one or more COBRA models from SBML, JSON, or MATLAB files.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>path</strong> (<em>Iterable</em>) – Paths to models or directories containing models.</p></li>
<li><p><strong>suffixes</strong> (<em>Iterable</em>) – File endings to use (sbml, xml, json, or mat).</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>COBRA models.</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>list</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="mptool.load_set">
<span class="sig-prename descclassname"><span class="pre">mptool.</span></span><span class="sig-name descname"><span class="pre">load_set</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">path</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#mptool.load_set" title="Link to this definition">¶</a></dt>
<dd><p>Loads a set of strings from file (one string per line).</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="mptool.load_sets">
<span class="sig-prename descclassname"><span class="pre">mptool.</span></span><span class="sig-name descname"><span class="pre">load_sets</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">path</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#mptool.load_sets" title="Link to this definition">¶</a></dt>
<dd><p>Loads a set of frozensets of strings from CSV file.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="mptool.make_irreversible">
<span class="sig-prename descclassname"><span class="pre">mptool.</span></span><span class="sig-name descname"><span class="pre">make_irreversible</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">model</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">subset</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">{}</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#mptool.make_irreversible" title="Link to this definition">¶</a></dt>
<dd><p>Makes reactions in subset of model positive and irreversible.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>model</strong> – COBRA or Gurobi model.</p></li>
<li><p><strong>subset</strong> – Iterable containing reactions to make irreversible or their IDs
(if empty, all reactions in model are made irreversible).</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>Subset with irreversible reactions.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="mptool.save_bounds">
<span class="sig-prename descclassname"><span class="pre">mptool.</span></span><span class="sig-name descname"><span class="pre">save_bounds</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">bounds</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">path</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#mptool.save_bounds" title="Link to this definition">¶</a></dt>
<dd><p>Writes bounds from dict to CSV file.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="mptool.save_set">
<span class="sig-prename descclassname"><span class="pre">mptool.</span></span><span class="sig-name descname"><span class="pre">save_set</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">s</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">path</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#mptool.save_set" title="Link to this definition">¶</a></dt>
<dd><p>Writes a set of strings to file (one string per line).</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="mptool.save_sets">
<span class="sig-prename descclassname"><span class="pre">mptool.</span></span><span class="sig-name descname"><span class="pre">save_sets</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">sets</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">path</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#mptool.save_sets" title="Link to this definition">¶</a></dt>
<dd><p>Writes sets of strings to CSV file.</p>
</dd></dl>

</section>
<section id="references">
<h1>References<a class="headerlink" href="#references" title="Link to this heading">¶</a></h1>
<p>[1] Øyås and Stelling. “Scalable metabolic pathway analysis”. biorXiv (2020).
<a class="reference external" href="https://www.biorxiv.org/content/10.1101/2020.07.31.230177v2">https://www.biorxiv.org/content/10.1101/2020.07.31.230177v2</a>.</p>
<p>[2] Klamt et al. “From elementary flux modes to elementary flux vectors:
Metabolic pathway analysis with arbitrary linear flux constraints”. PLoS
Computational Biology 13.4 (2017).</p>
<p>[3] Song et al. “Sequential computation of elementary modes and minimal cut
sets in genome-scale metabolic networks using alternate integer linear
programming”. Bioinformatics 33.15 (2017).</p>
</section>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="#">mptool</a></h1>








<h3>Navigation</h3>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="#">Documentation overview</a><ul>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &#169;2024, Ove Øyås.
      
      |
      Powered by <a href="https://www.sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://alabaster.readthedocs.io">Alabaster 0.7.16</a>
      
      |
      <a href="_sources/index.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>